<?php

class PatchHooks {
	static function postcommit() {

		global $db;
		$upg = AppConfig::setting('site.upgrade_in_progress');
		$start_ver = $upg ? array_get_default($upg, 'start_version') : null;
		
		require_once('modules/LicenseInfo/utils.php');
		repair_license($start_ver);
		
		require_once('modules/SystemMessages/utils.php');
		register_standard_messages();
		
		require_once('modules/PDFTemplates/PDFTemplate.php');
		PDFTemplate::update_defaults();

		require_once('modules/Recurrence/RecurrenceUpdate875.php');
		RecurrenceUpdate875::upgrade_875();

		require_once('modules/Administration/upgrade_utils.php');
		if(version_compare($start_ver, '8.5.0', '<')) {
			upgradePayments_850();
		}

		require_once('modules/Scheduler/utils.php');
		scheduler_rebuild_tasks();
		
		require_once('modules/Reports/utils.php');
		install_report_templates();

		$db->query(
			"UPDATE campaign_trkrs t LEFT JOIN campaigns c ON c.id = t.campaign_id"
			. " SET t.optout_type = IF (t.is_optout, if(c.campaign_type = 'NewsLetter', 'optout', 'optout-all'), IF (t.is_optin, 'optin', 'track')) WHERE IFNULL(t.optout_type, '') = ''"
		);
		
		require_once('modules/ACLActions/ACLAction.php');
		$modules = AppConfig::setting('modinfo.index.normal');
		
		foreach ($modules as $mod) {
			$acl = AppConfig::setting("modinfo.by_name.$mod.acl.fixed", []);
			$acl = array_map(['ACLAction', 'levelStringToInt'], $acl);
			foreach ($acl as $name => $level) {
				$db->query("update acl_actions  set aclaccess = '$level' where category = '$mod' and name='$name'  and acltype = 'module'");
			}
		}
	}

	static function check_multiple_recurrence() {
		global $db;
		$query = "SELECT COUNT(DISTINCT `id`) as `cnt` FROM `recurrence_rules` WHERE `deleted`=0 GROUP BY `parent_id` HAVING cnt > 1 LIMIT 1";
		$res = $db->query($query, true);
		$row = $db->fetchByAssoc($res);
		if (!$row || !$row['cnt'])
			return false;
		return [
			'label' => translate('ERR_MULTIPLE_RECURRENCE', 'UWizard'),
			'description' => translate('ERR_MULTIPLE_RECURRENCE_DESC', 'UWizard'),
		];
	}
}

?>
